$faded-color: #7a7971;
$color: #323232;
$color-disabled: #b6b6b6;
$value-color: #000000;
$armor-color: #2A8FBD;
$health-color: #A40802;
$attack-button-color: #171f69;
$damage-button-color: #5e0000;
$primary-accent: #5e0000;
$secondary-accent: #171f69;
$light-text: #f5efe0;
$common: #323232;
$uncommon: #98513d;
$rare: #002664;
$unique: #54166e;
$adjusted-higher: #009988;
$adjusted-lower: #cc3311;

@import "forms";
@import "data-entry";

.npc-sheet {
    @import "inventory";
    @import "spells";

    display: flex;
    flex-direction: row;
    align-items: flex-start;
    color: $color;

    .npc-sheet-header {
        display: flex;
        flex: 1 0 auto;
        flex-direction: column;

        .name {
            font-family: var(--sans-serif-condensed);
            font-size: 1.75rem;
            font-weight: 700;
            width: 100%;
            flex-wrap: nowrap;

            input {
                font-weight: inherit;
                height: 32px;
            }

            .name-value {
                font-variant: small-caps;
                margin-left: 6px;
                margin-right: 18px;
            }

            .level-label {
                flex: 0;
                text-align: right;
                margin-right: 0.1em;
                text-transform: uppercase;
            }

            input.level {
                flex: 0 0 40px;
                text-align: center;
            }
        }

        .traits-list-container {
            display: flex;
            flex-direction: row;
            flex-wrap: wrap;
            align-items: baseline;
            margin: 0px;
            padding: 4px;

            .traits-list-item {
                flex: auto 0 0;
                margin-left: 4px;
                margin-right: 4px;

                text-transform: uppercase;
                font-weight: bold;
            }

            .traits-list-item:first-child {
                margin-left: 0px;
                margin-right: 4px
            }

            .traits-list-item:last-child {
                margin-left: 4px;
                margin-right: 0px;
            }
        }
    }

    hr {
        margin: 10px 6px 10px 0;
      }

    .side-bar {
        flex: 160px 0 0;
        height: 100%;
        overflow: hidden scroll;

        .side-bar-section {
            display: flex;
            flex: auto;
            flex-direction: column;
            justify-content: flex-start;
            align-items: flex-start;

            .controls {
                padding-right: 4px;
            }
        }

        .side-bar-section-header {
            display: flex;
            width: 100%;
            font-size: 1.0rem;
            border-bottom: 1px solid;
            border-color: $faded-color;
            margin-top: 10px;
            margin-bottom: 0px;

            .side-bar-label {
                display: flex;
                flex: auto;
                flex-direction: row;
                align-items: flex-start;

                .fa {
                    font-size: 0.8rem;
                }

                h4 {
                    font-size: 0.8rem;
                    margin-bottom: 0px;
                    padding-left: 6px;
                }
            }
        }

        .side-bar-section-content {
            display: flex;
            width: 100%;
            flex-direction: row;
            flex-wrap: wrap;
            justify-content: flex-start;
            align-items: flex-start;
            padding-top: 2px;
        }

        .armor-section {
            .armor-label {
                color: $armor-color;
            }

            .armor-value {
                flex: 0;
                text-align: right;
                font-weight: 700;
                padding-right: 4px;
            }
        }

        .shield-section {
            .shield-label {
                display: flex;
                flex: auto;
                flex-direction: row;
                align-items: center;
                color: $armor-color;
            }

            .shield-value {
                display: flex;
                flex: auto;
                flex-direction: row;
                align-items: flex-end;
                text-align: right;
                font-weight: bold;
                color: $value-color;

                .shield-current {
                    flex: 0px;
                    font-weight: bold;
                    color: $value-color;
                    text-align: right;
                    width: 50px;
                }

                .shield-max {
                    flex: 0px;
                    align-self: center;
                    font-weight: bold;
                    color: $value-color;
                    text-align: left;
                }
            }

            .shield-details {
                display: flex;
                flex: auto;
                flex-direction: row;
                justify-content: flex-start;
                align-items: baseline;

                .label {
                    flex: 0;
                    font-weight: bold;
                }

                .value {
                    flex: auto;
                    font-weight: normal;
                    margin-left: 6px !important;
                }
            }

            &.broken  {
                color: rgba(black, 0.4);

                .shield-label {
                    color: rgba(black, 0.4);

                    h4 {
                        text-decoration: line-through;
                    }
                }

                .shield-value {
                    color: rgba(black, 0.4);

                    .shield-current {
                        color: rgba(black, 0.4);
                    }

                    .shield-max {
                        color: rgba(black, 0.4);
                    }
                }
            }
        }

        .health-section {
            .side-bar-label {
                align-items: center;
            }

            .health-value {
                display: flex;
                flex-direction: row;
                flex: 0;
                margin-left: auto;

                input {
                    &:first-child {
                        width: 36px;
                        text-align: right;
                        padding-right: 3px;
                    }
                    &:last-child {
                        font-weight: bold;
                        text-align: center;
                        margin-right: 4px;
                        &.lt10 {
                          width: 8px;
                        }
                        &.lt100 {
                          width: 24px;
                        }
                        &.lt1000 {
                          width: 36px;
                        }
                    }
                }
                span {
                    display: flex;
                    text-align: center;
                }
            }
        }

        .speed {
            .section-content {
                text-align: center;

                .land-speed {
                    font-size: 1em;
                }

                .other-speeds {
                    display: flex;
                    justify-content: center;
                    align-items: center;
                    width: 100%;
                    flex-wrap: wrap;
                }
            }
        }

        .saves {
            margin-top: 12px;
            display: flex;
            flex-direction: row;
            width: 100%;
            flex: 1 0 auto;
            font-size: 1.1rem;

            .container {
                display: flex;
                flex-direction: column;
                text-align: center;
                label {
                    font-weight: 600;
                }
                input.modifier {
                    text-align: center;
                    z-index: 1;
                }
            }
        }
    }

    .sheet-body {
        flex: auto;
        .tab {
            overflow: hidden scroll;
            

            .identification-skills {
                ul {
                    display: inline;
                    list-style-type: none;
                    padding: 0;

                    li {
                        display: inline;
                        &:not(:last-of-type):after {
                            content: ",";
                        }
                    }
                }
            }
        }
    }

    input.adjustable, span.adjustable {
        display: inline;
        text-align: right;

        &.adjusted-higher {
            color: $adjusted-higher;
        }

        &.adjusted-lower {
            color: $adjusted-lower;
        }
    }

    .controls {
        font-size: 0.8rem;
        display: flex;
        flex-wrap: nowrap;
        align-items: baseline;
        margin-left: auto;
        gap: 1px;

        .chat {
            margin-right: 3px;
            font-size: 0.9em;
        }
        > a.item-control {
            padding-left: 4px;
        }
    }

    .disabled {
        color: $color-disabled !important;
        border-color: $color-disabled !important;
    }

    .disabled:hover {
        color: $color !important;
        border-color: $faded-color !important;
    }

    .trait {
        flex: auto 0 0;
        padding: 4px;
        background: #5d0000;
        border: 2px solid #d8c384;
        color: $light-text;
        font-size: 0.9em;
        font-weight: 500;
        text-transform: uppercase;
    }

    .effects-list {
        display: flex;
        flex: 1 0 auto;
        flex-direction: row;
        flex-wrap: wrap;
        width: 100%;

        .separator {
            flex: 0 0 1px;
            height: 32px;
            margin-right: 4px;
            border-left: 2px solid $color;
        }

        > .effect {
            display: flex;
            flex: 0 0 32px;
            height: 32px;
            margin-right: 4px;
            margin-bottom: 4px;
            border-bottom: none !important;

            .item-image {
                background-size: cover;
                border: 1px solid $color;
                border-bottom: 1px solid $color;
                border-radius: 3px;
                width: 32px;
            }

            .item-image:hover {
                border: 1px solid $light-text;
                border-radius: 3px;
            }
        }
    }

    .actions-options {
        .actions-option {
            display: flex;
            align-items: center;
            width: 100%;

            label {
                width: 100%;

                * {
                    display: inline;
                    vertical-align: middle;
                }

                input {
                    margin: 0;
                    padding: 0;
                }
            }
        }
    }

    .actions-list {
        align-items: baseline;
        padding: 0px;
        margin: 0px;
        width: 97%;

        .action {
            display: flex;
            flex: 1 0 46%;
            margin-left: 6px;
            margin-right: 6px;
            flex-direction: column;
            justify-content: flex-start;
            width: 100%;
            margin-top: 6px;

            .action-header {
                display: flex;
                flex: 1 0 auto;
                flex-direction: row;
                justify-content: space-between;
                align-items: center;
                width: 100%;
                border-bottom: 1px solid $faded-color;

                .action-name {
                    display: flex;
                    flex: auto;
                    font-size: 0.9rem;

                    h4 {
                        margin: 0px;
                        margin-bottom: 0px;
                    }

                    .action-traits {
                        margin-left: 12px;
                    }
                }
            }

            .action-body {
                display: flex;
                flex: auto;
                width: 100%;
                justify-content: flex-start;
                align-items: flex-start;
                padding-top: 4px;
                padding-bottom: 4px;
                flex-direction: column;

                .sub-section {
                    display: flex;
                    width: 100%;
                    flex: auto;
                    flex-direction: row;
                    justify-content: flex-start;
                    align-items: flex-start;
                    flex-wrap: wrap;

                    h4 {
                        margin-left: 12px;
                        margin-right: 12px;
                    }
                }

                .btn {
                    width: auto !important;
                    cursor: pointer;
                    margin: 0 4px 4px 0;
                    padding: 0 12px;
                    font-size: 10px;
                    line-height: 16px;
                    box-shadow: inset 0 0 0 1px rgba(0, 0, 0, 0.3), inset 0 0 0 2px rgba(255, 255, 255, 0.2);
                    background: black;
                    color: $light-text;
                    text-align: center;
                    white-space: nowrap;
                    border-radius: 3px;
                    border: none;

                    &:first-child {
                        margin-left: 0px;
                    }

                    &:hover {
                        box-shadow: none;
                        text-shadow: 0 0 2px white;
                    }
                }

                .action-detail {
                    .traits-list {
                        display: flex;
                        flex: auto;
                        width: 100%;
                        flex-direction: row;
                        justify-content: flex-start;
                        align-items: baseline;
                        border-bottom: 1px solid $faded-color;
                        padding-bottom: 6px;
                    }
                }
            }
        }
    }

    .expandable {
        display: none;
    }

    .labelled-field {
        display: flex;
        flex-direction: row;
        align-items: baseline;

        label {
            flex: 1;
            font-weight: bold;
        }

        input[type="text"], input[type="number"] {
            flex: 0;
            font-weight: normal;
            margin: 1px 4px;
            margin-left: auto;
            min-width: 2.5em;
            padding-right: 1px;
            text-align: right;
        }
        &.hp-temp > label {
            margin-right: 0.5em;
        }
    }

    .top-sections {
        display: flex;
        flex-direction: row;
        justify-content: flex-start;
        align-items: flex-start;

        .skills {
            flex: 3;
            align-self: stretch;
        }

        .senses {
            flex: 2;

            .perception {
                width: 100%;
                label {
                    flex-basis: 5em;
                }
                input {
                    flex: 0 0 24px;
                    z-index: 1;
                }
            }
        }

        .ability-scores {
            flex: 2;
            flex-direction: column;

            .list {
                display: grid;
                padding-left: 0.75em;
                grid-template-columns: repeat(3, minmax(0, 1fr));
                input {
                    flex: 0 0 24px;
                    margin-right: 1em;
                    z-index: 1;
                }
            }
        }
    }

    .section-container {
        display: flex;
        flex-direction: column;
        padding: 4px 6px 0;

        .section-header {
            display: flex;
            flex: 0;
            width: 100%;
            flex-direction: row;
            justify-content: space-between;
            align-items: baseline;
            border: 1px solid $primary-accent;
            border-radius: 3px 3px 0px 0px;
            background: $primary-accent;
            text-align: left;
            color: $light-text;
            font-size: 0.8rem;
            padding: 4px 8px;

            h4 {
                flex: auto;
                margin-bottom: 0px;
                text-transform: uppercase;
            }
        }

        .section-body {
            display: flex;
            flex: auto;
            flex-wrap: wrap;
            width: 100%;
            flex-direction: row;
            justify-content: flex-start;
            align-items: baseline;
            padding: 4px;
            border: 1px solid $primary-accent;
            border-radius: 0px 0px 3px 3px;
        }

        &.headerless .section-body {
            border-radius: 3px;
        }

        &.skills > .section-body {
            .list {
                display: flex;
                flex-direction: row;
                flex-wrap: wrap;
            }
        }

        &.recall-knowledge {
            .section-header {
                align-items: center;

                .breakdown {
                    width: auto;
                    cursor: pointer;
                    font-size: 9px;
                    line-height: 15px;
                    box-shadow: inset 0 0 0 1px rgba(0, 0, 0, 0.3), inset 0 0 0 2px rgba(255, 255, 255, 0.2);
                    background: $secondary-color;
                    color: $light-text;
                    font-family: var(--sans-serif);
                    text-transform: uppercase;
                    border-radius: 3px;
                    border: none;
                    padding: 2px 4px 0;

                    &:hover {
                        box-shadow: none;
                        text-shadow: 0 0 2px white;
                    }
                }
            }
        }

        &.languages {
            flex: 1;
        }
    }

    .attacks {
        .section-header .controls {
            gap: 8px;
        }

        .section-body {
            padding: 0 4px;

            /** So it looks better empty since we removed vertical padding */
            min-height: 10px;
        }
    }

    .attacks-list {
        width: 100%;
        padding: 0px;
        margin: 0px;

        .attack {
            display: flex;
            flex-direction: column;
            justify-content: flex-start;

            margin: 8px 6px 0 6px;
            border-bottom: 1px solid $faded-color;

            &:last-child {
                border-bottom: none;
            }

            .attack-header {
                display: flex;
                flex: 1 0 auto;
                flex-direction: row;
                align-items: baseline;
                width: 100%;
            }

            .attack-name {
                display: flex;
                flex-wrap: wrap;
                align-items: center;
                gap: 2px;
                white-space: nowrap;
                margin: 0 4px 0 0;

                font-size: 0.9rem;
                font-weight: 800;

                span {
                    gap: 3px;
                    display: flex;
                    align-items: baseline;
                    line-height: 1.125rem;
                }
            }

            .activity-icon {
                margin-right: 4px;
            }

            .attack-body {
                display: flex;
                align-items: flex-start;
                flex-direction: column;

                width: 100%;
                padding-top: 3px;

                .flexrow, .sub-section {
                    gap: 2px;
                }

                .sub-section {
                    display: flex;
                    flex: auto;
                    flex-direction: row;
                    justify-content: flex-start;
                    align-items: flex-start;
                    flex-wrap: wrap;

                    h4 {
                        margin-left: 12px;
                        margin-right: 12px;
                    }
                }

                button {
                    width: auto !important;
                    cursor: pointer;
                    margin: 0;
                    padding: 0 8px;
                    font-size: 10px;
                    height: 18px;
                    line-height: 18px;
                    box-shadow: inset 0 0 0 1px rgba(0, 0, 0, 0.3), inset 0 0 0 2px rgba(255, 255, 255, 0.2);
                    background: $attack-button-color;
                    color: $light-text;
                    text-align: center;
                    white-space: nowrap;
                    border-radius: 3px;
                    border: none;

                    &:first-child {
                        margin-left: 0px;
                    }

                    &:hover {
                        box-shadow: none;
                        text-shadow: 0 0 2px white;
                    }
                }

                .attack-button {
                    background-color: $attack-button-color;
                }

                .damage-button, .critical-button {
                    background-color: $damage-button-color;
                }

                .attack-description {
                    min-height: 10px;
                }
            }
        }
    }

    .tag {
        line-height: 0.8rem;
    }

    select {
        flex: auto 0 0;
        padding: 4px !important;
        height: auto !important;
        font-family: var(--sans-serif);
        font-weight: 500;
        text-transform: uppercase;

    }

    .alignment-select {
        background: #566193 !important;
        border: 2px solid #d8c384 !important;
        color: white !important;
    }

    .size-select {
        background: #3a7a58 !important;
        border: 2px solid #d8c384 !important;
        color: white !important;
    }

    .rarity-select {
        border: 2px solid #d8c384 !important;
        color: white !important;

        &.common {
            background: $common !important;
        }
        &.uncommon {
            background: $uncommon !important;
        }
        &.rare {
            background: $rare !important;
        }
        &.unique {
            background: $unique !important;
        }
    }

    .adjustment-select {

        .adjustment {

            &.active {
                background-color: $primary-accent !important;
                color: $light-text;
            }

            &:not(.active) {
                background-color: $faded-color !important;
                color: $light-text !important;
            }
        }
    }

    .npc-body {
        display: flex;
        flex: auto;
        flex-direction: column;
        height: 100%;
        width: 100%;
        overflow-y: hidden;
    }

    .notes {
        padding-right: 15px;

        &.active {
            display: flex;
            flex-direction: column;
        }

        .details-label {
            padding: 4px;
            font-family: var(--sans-serif);
            font-size: 10px;
            font-weight: 800;
            line-height: 1;
            text-transform: uppercase;
            color: var(--primary);
        
            margin-right: 2px;
            white-space: nowrap;
        }

        .notes-section {
            flex: 1 0 auto;
            display: flex;
            flex-direction: column;
        }

        .notes-text {
            margin-left: 8px;
            padding: 4px;
            color: #333;
            flex-grow: 1;
    
            .editor {
                height: 100%;
                .editor-edit {
                    background: var(--primary);
                    color: white;
                }
    
                .editor-content {
                    min-height: 75px;
                    height: 100%;
                }
            }
        }

        .source {
            flex-shrink: 0;

            .section-body {
                border-width: 2px;
            }

            label {
                margin-right: 4px;
                flex: 0;
                font-weight: 700;
            }

            .source-input {
                flex: 2;
            }
        }
    }
    
    &.dead {
        .profile {
            background-size: cover;
            background-color: #dbd9cd;
            box-sizing: border-box;
            border: 1px solid black;
            border-radius: 2px;
            > img {
                border: none;
                width: 100%;
                opacity: 0.33;
            }
        }
        h2.name {
            margin-top: 3px;
            text-align: center;
            border-bottom: none;
        }
    }
}
